target datalayout = "e-p:64:64:64-i1:8:8-i8:8:8-i16:16:16-i32:32:32-i64:64:64-f32:32:32-f64:64:64-v16:16:16-v24:32:32-v32:32:32-v48:64:64-v64:64:64-v96:128:128-v128:128:128-v192:256:256-v256:256:256-v512:512:512-v1024:1024:1024"
target triple = "spir64-unknown-unknown"

%spirv.Pipe._1 = type opaque
%spirv.ReserveId = type opaque
%spirv.Pipe._0 = type opaque

; Function Attrs: nounwind
define spir_kernel void @test_pipe_write_long16(<16 x i64> addrspace(1)* %src, %spirv.Pipe._1 addrspace(1)* %out_pipe) #0 {
entry:
  %0 = call spir_func <3 x i64> @BuiltInGlobalInvocationId() #1
  %call = extractelement <3 x i64> %0, i32 0
  %conv = trunc i64 %call to i32
  %1 = call spir_func %spirv.ReserveId* @OpReserveWritePipePackets_Pipe_wo_i32_i32_i32(%spirv.Pipe._1 addrspace(1)* %out_pipe, i32 1, i32 128, i32 128) #0
  %call1 = call spir_func i1 @OpIsValidReserveId_ReserveId(%spirv.ReserveId* %1) #0
  br i1 %call1, label %if.then, label %if.end

if.then:                                          ; preds = %entry
  %idxprom = sext i32 %conv to i64
  %arrayidx = getelementptr inbounds <16 x i64>, <16 x i64> addrspace(1)* %src, i64 %idxprom
  %2 = addrspacecast <16 x i64> addrspace(1)* %arrayidx to i8 addrspace(4)*
  %3 = call spir_func i32 @OpReservedWritePipe_Pipe_wo_ReserveId_i32_p4i8_i32_i32(%spirv.Pipe._1 addrspace(1)* %out_pipe, %spirv.ReserveId* %1, i32 0, i8 addrspace(4)* %2, i32 128, i32 128) #0
  call spir_func void @OpCommitWritePipe_Pipe_wo_ReserveId_i32_i32(%spirv.Pipe._1 addrspace(1)* %out_pipe, %spirv.ReserveId* %1, i32 128, i32 128) #0
  br label %if.end

if.end:                                           ; preds = %if.then, %entry
  ret void
}

; Function Attrs: nounwind
declare spir_func %spirv.ReserveId* @OpReserveWritePipePackets_Pipe_wo_i32_i32_i32(%spirv.Pipe._1 addrspace(1)*, i32, i32, i32) #0

; Function Attrs: nounwind
declare spir_func i1 @OpIsValidReserveId_ReserveId(%spirv.ReserveId*) #0

; Function Attrs: nounwind
declare spir_func i32 @OpReservedWritePipe_Pipe_wo_ReserveId_i32_p4i8_i32_i32(%spirv.Pipe._1 addrspace(1)*, %spirv.ReserveId*, i32, i8 addrspace(4)*, i32, i32) #0

; Function Attrs: nounwind
declare spir_func void @OpCommitWritePipe_Pipe_wo_ReserveId_i32_i32(%spirv.Pipe._1 addrspace(1)*, %spirv.ReserveId*, i32, i32) #0

; Function Attrs: nounwind
define spir_kernel void @test_pipe_read_long16(%spirv.Pipe._0 addrspace(1)* %in_pipe, <16 x i64> addrspace(1)* %dst) #0 {
entry:
  %0 = call spir_func <3 x i64> @BuiltInGlobalInvocationId() #1
  %call = extractelement <3 x i64> %0, i32 0
  %conv = trunc i64 %call to i32
  %1 = call spir_func %spirv.ReserveId* @OpReserveReadPipePackets_Pipe_ro_i32_i32_i32(%spirv.Pipe._0 addrspace(1)* %in_pipe, i32 1, i32 128, i32 128) #0
  %call1 = call spir_func i1 @OpIsValidReserveId_ReserveId(%spirv.ReserveId* %1) #0
  br i1 %call1, label %if.then, label %if.end

if.then:                                          ; preds = %entry
  %idxprom = sext i32 %conv to i64
  %arrayidx = getelementptr inbounds <16 x i64>, <16 x i64> addrspace(1)* %dst, i64 %idxprom
  %2 = addrspacecast <16 x i64> addrspace(1)* %arrayidx to i8 addrspace(4)*
  %3 = call spir_func i32 @OpReservedReadPipe_Pipe_ro_ReserveId_i32_p4i8_i32_i32(%spirv.Pipe._0 addrspace(1)* %in_pipe, %spirv.ReserveId* %1, i32 0, i8 addrspace(4)* %2, i32 128, i32 128) #0
  call spir_func void @OpCommitReadPipe_Pipe_ro_ReserveId_i32_i32(%spirv.Pipe._0 addrspace(1)* %in_pipe, %spirv.ReserveId* %1, i32 128, i32 128) #0
  br label %if.end

if.end:                                           ; preds = %if.then, %entry
  ret void
}

; Function Attrs: nounwind
declare spir_func %spirv.ReserveId* @OpReserveReadPipePackets_Pipe_ro_i32_i32_i32(%spirv.Pipe._0 addrspace(1)*, i32, i32, i32) #0

; Function Attrs: nounwind
declare spir_func i32 @OpReservedReadPipe_Pipe_ro_ReserveId_i32_p4i8_i32_i32(%spirv.Pipe._0 addrspace(1)*, %spirv.ReserveId*, i32, i8 addrspace(4)*, i32, i32) #0

; Function Attrs: nounwind
declare spir_func void @OpCommitReadPipe_Pipe_ro_ReserveId_i32_i32(%spirv.Pipe._0 addrspace(1)*, %spirv.ReserveId*, i32, i32) #0

; Function Attrs: nounwind readnone
declare spir_func <3 x i64> @BuiltInGlobalInvocationId() #1

attributes #0 = { nounwind }
attributes #1 = { nounwind readnone }

!opencl.kernels = !{!0, !7}
!IGCMetadata = !{!13}
!opencl.enable.FP_CONTRACT = !{}
!opencl.spir.version = !{!248}
!opencl.ocl.version = !{!248}
!opencl.used.extensions = !{!249}
!opencl.used.optional.core.features = !{!249}
!opencl.compiler.options = !{!250}

!0 = !{void (<16 x i64> addrspace(1)*, %spirv.Pipe._1 addrspace(1)*)* @test_pipe_write_long16, !1, !2, !3, !4, !5, !6}
!1 = !{!"kernel_arg_addr_space", i32 1, i32 1}
!2 = !{!"kernel_arg_access_qual", !"none", !"write_only"}
!3 = !{!"kernel_arg_type", !"long16*", !"long __attribute__((ext_vector_type(16)))"}
!4 = !{!"kernel_arg_type_qual", !"", !"pipe"}
!5 = !{!"kernel_arg_base_type", !"long16*", !"pipe"}
!6 = !{!"kernel_arg_name", !"src", !"out_pipe"}
!7 = !{void (%spirv.Pipe._0 addrspace(1)*, <16 x i64> addrspace(1)*)* @test_pipe_read_long16, !1, !8, !9, !10, !11, !12}
!8 = !{!"kernel_arg_access_qual", !"read_only", !"none"}
!9 = !{!"kernel_arg_type", !"long __attribute__((ext_vector_type(16)))", !"long16*"}
!10 = !{!"kernel_arg_type_qual", !"pipe", !""}
!11 = !{!"kernel_arg_base_type", !"pipe", !"long16*"}
!12 = !{!"kernel_arg_name", !"in_pipe", !"dst"}
!13 = !{!"ModuleMD", !14, !15, !70, !129, !159, !175, !187, !197, !199, !200, !211, !212, !213, !214, !217, !218, !219, !220, !221, !222, !223, !224, !225, !226, !227, !228, !230, !234, !235, !236, !237, !238, !239, !114, !240, !241, !243, !246, !247}
!14 = !{!"isPrecise", i1 false}
!15 = !{!"compOpt", !16, !17, !18, !19, !20, !21, !22, !23, !24, !25, !26, !27, !28, !29, !30, !31, !32, !33, !34, !35, !36, !37, !38, !39, !40, !41, !42, !43, !44, !45, !46, !47, !48, !49, !50, !51, !52, !53, !54, !55, !56, !57, !58, !59, !60, !61, !62, !63, !64, !65, !66, !67, !68, !69}
!16 = !{!"DenormsAreZero", i1 false}
!17 = !{!"CorrectlyRoundedDivSqrt", i1 false}
!18 = !{!"OptDisable", i1 false}
!19 = !{!"MadEnable", i1 false}
!20 = !{!"NoSignedZeros", i1 false}
!21 = !{!"NoNaNs", i1 false}
!22 = !{!"FloatRoundingMode", i32 0}
!23 = !{!"FloatCvtIntRoundingMode", i32 3}
!24 = !{!"VISAPreSchedRPThreshold", i32 0}
!25 = !{!"SetLoopUnrollThreshold", i32 0}
!26 = !{!"UnsafeMathOptimizations", i1 false}
!27 = !{!"FiniteMathOnly", i1 false}
!28 = !{!"FastRelaxedMath", i1 false}
!29 = !{!"DashGSpecified", i1 false}
!30 = !{!"FastCompilation", i1 false}
!31 = !{!"UseScratchSpacePrivateMemory", i1 true}
!32 = !{!"RelaxedBuiltins", i1 false}
!33 = !{!"SubgroupIndependentForwardProgressRequired", i1 true}
!34 = !{!"GreaterThan2GBBufferRequired", i1 true}
!35 = !{!"GreaterThan4GBBufferRequired", i1 true}
!36 = !{!"DisableA64WA", i1 false}
!37 = !{!"ForceEnableA64WA", i1 false}
!38 = !{!"PushConstantsEnable", i1 true}
!39 = !{!"HasPositivePointerOffset", i1 false}
!40 = !{!"HasBufferOffsetArg", i1 false}
!41 = !{!"BufferOffsetArgOptional", i1 true}
!42 = !{!"HasSubDWAlignedPtrArg", i1 false}
!43 = !{!"replaceGlobalOffsetsByZero", i1 false}
!44 = !{!"forcePixelShaderSIMDMode", i32 0}
!45 = !{!"pixelShaderDoNotAbortOnSpill", i1 false}
!46 = !{!"UniformWGS", i1 false}
!47 = !{!"disableVertexComponentPacking", i1 false}
!48 = !{!"disablePartialVertexComponentPacking", i1 false}
!49 = !{!"PreferBindlessImages", i1 false}
!50 = !{!"UseBindlessMode", i1 false}
!51 = !{!"UseLegacyBindlessMode", i1 true}
!52 = !{!"disableMathRefactoring", i1 false}
!53 = !{!"atomicBranch", i1 false}
!54 = !{!"ForceMinSimdSizeForFastestCS", i1 false}
!55 = !{!"EnableFastestLinearScan", i1 false}
!56 = !{!"UseStatelessforPrivateMemory", i1 false}
!57 = !{!"EnableTakeGlobalAddress", i1 false}
!58 = !{!"IsLibraryCompilation", i1 false}
!59 = !{!"FastVISACompile", i1 false}
!60 = !{!"MatchSinCosPi", i1 false}
!61 = !{!"CaptureCompilerStats", i1 false}
!62 = !{!"EnableZEBinary", i1 false}
!63 = !{!"ExcludeIRFromZEBinary", i1 false}
!64 = !{!"allowDisableRematforCS", i1 false}
!65 = !{!"DisableIncSpillCostAllAddrTaken", i1 false}
!66 = !{!"DisableCPSOmaskWA", i1 false}
!67 = !{!"DisableFastestGopt", i1 false}
!68 = !{!"WaForceHalfPromotion", i1 false}
!69 = !{!"EnableUndefAlphaOutputAsRed", i1 true}
!70 = !{!"FuncMD", !71, !72, !127, !128}
!71 = !{!"FuncMDMap[0]", void (<16 x i64> addrspace(1)*, %spirv.Pipe._1 addrspace(1)*)* @test_pipe_write_long16}
!72 = !{!"FuncMDValue[0]", !73, !74, !78, !79, !80, !100, !106, !107, !108, !109, !110, !111, !112, !113, !114, !115, !116, !117, !118, !119, !120, !121, !122, !123, !124, !125, !126}
!73 = !{!"localOffsets"}
!74 = !{!"workGroupWalkOrder", !75, !76, !77}
!75 = !{!"dim0", i32 0}
!76 = !{!"dim1", i32 0}
!77 = !{!"dim2", i32 0}
!78 = !{!"funcArgs"}
!79 = !{!"functionType", !"KernelFunction"}
!80 = !{!"rtInfo", !81, !82, !83, !84, !85, !86, !87, !88, !89, !90, !91, !92, !93, !94, !95, !99}
!81 = !{!"callableShaderType", !"NumberOfCallableShaderTypes"}
!82 = !{!"isContinuation", i1 false}
!83 = !{!"hasTraceRayPayload", i1 false}
!84 = !{!"hasHitAttributes", i1 false}
!85 = !{!"hasCallableData", i1 false}
!86 = !{!"ShaderStackSize", i32 0}
!87 = !{!"ShaderHash", i64 0}
!88 = !{!"ShaderName", !""}
!89 = !{!"ParentName", !""}
!90 = !{!"SlotNum", i1* null}
!91 = !{!"NOSSize", i32 0}
!92 = !{!"Entries"}
!93 = !{!"SpillUnions"}
!94 = !{!"CustomHitAttrSizeInBytes", i32 0}
!95 = !{!"Types", !96, !97, !98}
!96 = !{!"FrameStartTys"}
!97 = !{!"ArgumentTys"}
!98 = !{!"FullFrameTys"}
!99 = !{!"Aliases"}
!100 = !{!"resAllocMD", !101, !102, !103, !104, !105}
!101 = !{!"uavsNumType", i32 0}
!102 = !{!"srvsNumType", i32 0}
!103 = !{!"samplersNumType", i32 0}
!104 = !{!"argAllocMDList"}
!105 = !{!"inlineSamplersMD"}
!106 = !{!"maxByteOffsets"}
!107 = !{!"IsInitializer", i1 false}
!108 = !{!"IsFinalizer", i1 false}
!109 = !{!"CompiledSubGroupsNumber", i32 0}
!110 = !{!"hasInlineVmeSamplers", i1 false}
!111 = !{!"localSize", i32 0}
!112 = !{!"localIDPresent", i1 false}
!113 = !{!"groupIDPresent", i1 false}
!114 = !{!"privateMemoryPerWI", i32 0}
!115 = !{!"globalIDPresent", i1 false}
!116 = !{!"hasSyncRTCalls", i1 false}
!117 = !{!"hasNonKernelArgLoad", i1 false}
!118 = !{!"hasNonKernelArgStore", i1 false}
!119 = !{!"hasNonKernelArgAtomic", i1 false}
!120 = !{!"UserAnnotations"}
!121 = !{!"m_OpenCLArgAddressSpaces"}
!122 = !{!"m_OpenCLArgAccessQualifiers"}
!123 = !{!"m_OpenCLArgTypes"}
!124 = !{!"m_OpenCLArgBaseTypes"}
!125 = !{!"m_OpenCLArgTypeQualifiers"}
!126 = !{!"m_OpenCLArgNames"}
!127 = !{!"FuncMDMap[1]", void (%spirv.Pipe._0 addrspace(1)*, <16 x i64> addrspace(1)*)* @test_pipe_read_long16}
!128 = !{!"FuncMDValue[1]", !73, !74, !78, !79, !80, !100, !106, !107, !108, !109, !110, !111, !112, !113, !114, !115, !116, !117, !118, !119, !120, !121, !122, !123, !124, !125, !126}
!129 = !{!"pushInfo", !130, !131, !132, !135, !136, !137, !138, !139, !140, !141, !142, !155, !156, !157, !158}
!130 = !{!"pushableAddresses"}
!131 = !{!"bindlessPushInfo"}
!132 = !{!"dynamicBufferInfo", !133, !134}
!133 = !{!"firstIndex", i32 0}
!134 = !{!"numOffsets", i32 0}
!135 = !{!"MaxNumberOfPushedBuffers", i32 0}
!136 = !{!"inlineConstantBufferSlot", i32 -1}
!137 = !{!"inlineConstantBufferOffset", i32 -1}
!138 = !{!"inlineConstantBufferGRFOffset", i32 -1}
!139 = !{!"constants"}
!140 = !{!"inputs"}
!141 = !{!"constantReg"}
!142 = !{!"simplePushInfoArr", !143, !152, !153, !154}
!143 = !{!"simplePushInfoArrVec[0]", !144, !145, !146, !147, !148, !149, !150, !151}
!144 = !{!"cbIdx", i32 0}
!145 = !{!"pushableAddressGrfOffset", i32 -1}
!146 = !{!"pushableOffsetGrfOffset", i32 -1}
!147 = !{!"offset", i32 0}
!148 = !{!"size", i32 0}
!149 = !{!"isStateless", i1 false}
!150 = !{!"isBindless", i1 false}
!151 = !{!"simplePushLoads"}
!152 = !{!"simplePushInfoArrVec[1]", !144, !145, !146, !147, !148, !149, !150, !151}
!153 = !{!"simplePushInfoArrVec[2]", !144, !145, !146, !147, !148, !149, !150, !151}
!154 = !{!"simplePushInfoArrVec[3]", !144, !145, !146, !147, !148, !149, !150, !151}
!155 = !{!"simplePushBufferUsed", i32 0}
!156 = !{!"pushAnalysisWIInfos"}
!157 = !{!"inlineRTGlobalPtrOffset", i32 0}
!158 = !{!"rtSyncSurfPtrOffset", i32 0}
!159 = !{!"psInfo", !160, !161, !162, !163, !164, !165, !166, !167, !168, !169, !170, !171, !172, !173, !174}
!160 = !{!"BlendStateDisabledMask", i8 0}
!161 = !{!"SkipSrc0Alpha", i1 false}
!162 = !{!"DualSourceBlendingDisabled", i1 false}
!163 = !{!"ForceEnableSimd32", i1 false}
!164 = !{!"outputDepth", i1 false}
!165 = !{!"outputStencil", i1 false}
!166 = !{!"outputMask", i1 false}
!167 = !{!"blendToFillEnabled", i1 false}
!168 = !{!"forceEarlyZ", i1 false}
!169 = !{!"hasVersionedLoop", i1 false}
!170 = !{!"forceSingleSourceRTWAfterDualSourceRTW", i1 false}
!171 = !{!"NumSamples", i8 0}
!172 = !{!"blendOptimizationMode"}
!173 = !{!"colorOutputMask"}
!174 = !{!"WaDisableVRS", i1 false}
!175 = !{!"csInfo", !176, !177, !178, !179, !180, !24, !25, !181, !182, !183, !184, !185, !53, !186}
!176 = !{!"maxWorkGroupSize", i32 0}
!177 = !{!"waveSize", i32 0}
!178 = !{!"ComputeShaderSecondCompile"}
!179 = !{!"forcedSIMDSize", i8 0}
!180 = !{!"forceTotalGRFNum", i32 0}
!181 = !{!"forcedVISAPreRAScheduler", i1 false}
!182 = !{!"disableLocalIdOrderOptimizations", i1 false}
!183 = !{!"disableDispatchAlongY", i1 false}
!184 = !{!"neededThreadIdLayout", i1* null}
!185 = !{!"forceTileYWalk", i1 false}
!186 = !{!"ResForHfPacking"}
!187 = !{!"msInfo", !188, !189, !190, !191, !192, !193, !194, !195, !196}
!188 = !{!"PrimitiveTopology", i32 3}
!189 = !{!"MaxNumOfPrimitives", i32 0}
!190 = !{!"MaxNumOfVertices", i32 0}
!191 = !{!"MaxNumOfPerPrimitiveOutputs", i32 0}
!192 = !{!"MaxNumOfPerVertexOutputs", i32 0}
!193 = !{!"WorkGroupSize", i32 0}
!194 = !{!"WorkGroupMemorySizeInBytes", i32 0}
!195 = !{!"IndexFormat", i32 6}
!196 = !{!"SubgroupSize", i32 0}
!197 = !{!"taskInfo", !198, !193, !194, !196}
!198 = !{!"MaxNumOfOutputs", i32 0}
!199 = !{!"NBarrierCnt", i32 0}
!200 = !{!"rtInfo", !201, !202, !203, !204, !205, !206, !207, !208, !209, !210}
!201 = !{!"RayQueryAllocSizeInBytes", i32 0}
!202 = !{!"NumContinuations", i32 -1}
!203 = !{!"RTAsyncStackAddrspace", i32 -1}
!204 = !{!"RTAsyncStackSurfaceStateOffset", i1* null}
!205 = !{!"SWHotZoneAddrspace", i32 -1}
!206 = !{!"SWHotZoneSurfaceStateOffset", i1* null}
!207 = !{!"SWStackAddrspace", i32 -1}
!208 = !{!"SWStackSurfaceStateOffset", i1* null}
!209 = !{!"RTSyncStackAddrspace", i32 -1}
!210 = !{!"RTSyncStackSurfaceStateOffset", i1* null}
!211 = !{!"CurUniqueIndirectIdx", i32 0}
!212 = !{!"inlineDynTextures"}
!213 = !{!"inlineResInfoData"}
!214 = !{!"immConstant", !215, !216}
!215 = !{!"data"}
!216 = !{!"sizes"}
!217 = !{!"inlineConstantBuffers"}
!218 = !{!"inlineGlobalBuffers"}
!219 = !{!"GlobalPointerProgramBinaryInfos"}
!220 = !{!"ConstantPointerProgramBinaryInfos"}
!221 = !{!"GlobalBufferAddressRelocInfo"}
!222 = !{!"ConstantBufferAddressRelocInfo"}
!223 = !{!"forceLscCacheList"}
!224 = !{!"SrvMap"}
!225 = !{!"RasterizerOrderedByteAddressBuffer"}
!226 = !{!"MinNOSPushConstantSize", i32 0}
!227 = !{!"inlineProgramScopeOffsets"}
!228 = !{!"shaderData", !229}
!229 = !{!"numReplicas", i32 0}
!230 = !{!"URBInfo", !231, !232, !233}
!231 = !{!"has64BVertexHeaderInput", i1 false}
!232 = !{!"has64BVertexHeaderOutput", i1 false}
!233 = !{!"hasVertexHeader", i1 true}
!234 = !{!"UseBindlessImage", i1 false}
!235 = !{!"enableRangeReduce", i1 false}
!236 = !{!"allowMatchMadOptimizationforVS", i1 false}
!237 = !{!"disableMemOptforNegativeOffsetLoads", i1 false}
!238 = !{!"statefulResourcesNotAliased", i1 false}
!239 = !{!"disableMixMode", i1 false}
!240 = !{!"PrivateMemoryPerFG"}
!241 = !{!"capabilities", !242}
!242 = !{!"globalVariableDecorationsINTEL", i1 false}
!243 = !{!"m_ShaderResourceViewMcsMask", !244, !245}
!244 = !{!"m_ShaderResourceViewMcsMaskVec[0]", i64 0}
!245 = !{!"m_ShaderResourceViewMcsMaskVec[1]", i64 0}
!246 = !{!"computedDepthMode", i32 0}
!247 = !{!"isHDCFastClearShader", i1 false}
!248 = !{i32 3, i32 0}
!249 = !{}
!250 = !{!"-cl-std=CL3.0"}
